import collections

class Chaine:
    def __init__(self, value, next):
        self.value = value
        self.next = next

    def fin_de_chaine(self):
        return self.value == None and self.next == None

class List(collections.abc.MutableSequence):
    def __init__(self):
        self._debut_chaine = Chaine(None, None)
        self._fin_chaine = self._debut_chaine
        # self._length = 0 on peut aussi maintenir l'information dynamiquement

    def __iter_chaine__(self):
        def generateur():
            C = self._debut_chaine
            while not C.fin_de_chaine():
                yield C
                C = C.next
        return generateur()

    def __iter__(self):
        def generateur():
            for x in self.__iter_chaine__():
                yield x.value
        return generateur()

    def __iter__(self):
        return map(lambda e:e.value, self.__iter_chaine__())

    def __len__(self):
        c = 0
        for _ in self:
            c += 1
        return c

    def __len__(self):
        return sum(map(lambda e:1, self))

    def __setitem__(self, index, value):
        for i, C in enumerate(self.__iter_chaine__())
            if i == index:
                C.value = value
                return 
        raise IndexError("")

    def __getitem__(self, index):
        for i, C in enumerate(self.__iter_chaine__()):
            if i == index:
                return C.value
        raise IndexError("")

    def __delitem__(self, index):
        if index == 0:
            self._debut_chaine = self._debut_chaine.next
        it = iter(self)
        try:
            for i in range(index-1):
                next(it)
            avant = next(it)
            a_supprimer = next(it)
        except StopIteration:
            raise IndexError("")
        avant.next = a_supprimer.next

    def insert(self, index, value):
        if index == 0:
            self._debut_chaine = Chaine(self._debut_chaine, value)
        it = iter(self)
        try:
            for i in range(index-1):
                next(it)
            avant = next(it)
            C = Chaine(avant.next, value)
            avant.next = C

        except StopIteration:
            raise IndexError("")

    def __getitem__(self, index):
        for i, v in enumerate(self):
            if i == index:
                return v
        raise IndexError("")




